#include <iostream>
#include <iomanip>
#include "part1.hpp"

int main(int argc, char* argv[]) {

  auto ta = make_ref("tata");
  auto to = make_ref("toto");
  auto ti = make_ref("titi");
  auto tu = make_ref("tutu");
  auto tU = make_ref("tutu");
  auto ra = make_ref("rara");
  auto ro = make_ref("roro");
  auto za = make_ref("zaza");
  auto zo = make_ref("zozo");

  ref_set A {ta, to, ti, tu, za};
  ref_set B {ti, tU, ra, ro, zo};
  ref_set C = A || B;
  ref_set D = A && B;
  ref_set E {ti, tU};

  // The order in the inputs is allowed to be different for you.
  std::cout << std::boolalpha
	    << A << std::endl         // Output : {tata, toto, titi, tutu, zaza}
	    << B << std::endl         // Output : {titi, tutu, rara, roro, zozo}
	    << C << std::endl         // Output : {tata, toto, titi, tutu, zaza, rara, roro, zozo}
	    << D << std::endl         // Output : {titi, tutu}
	    << (A == B) << std::endl  // Output : false
	    << (E == D) << std::endl; // Output : true
  
  return 0;
}
