#include <iostream>
#include "part3.hpp"

int main(int argc, char* argv[]) {

  
  ref_set<int> A {ref_set<int>::make_ref(1), ref_set<int>::make_ref(2), ref_set<int>::make_ref(3), ref_set<int>::make_ref(4)};
  auto B = A.apply([](int x){return x*x;});
  auto C = A || B;
  ref_set<ref_set<int>> D;
  D += ref_set<ref_set<int>>::make_ref(A);
  D += ref_set<ref_set<int>>::make_ref(A);
  D += ref_set<ref_set<int>>::make_ref(A);
  D += ref_set<ref_set<int>>::make_ref(B);
  D += ref_set<ref_set<int>>::make_ref(C);

  // The order in the inputs is allowed to be different for you.
  std::cout << A << std::endl  // Output : {1, 2, 3, 4}
	    << B << std::endl  // output : {1, 4, 9, 16}
	    << C << std::endl  // Output : {1, 2, 3, 4, 9, 16}
	    << D << std::endl; // output : {{1, 2, 3, 4}, {1, 4, 9, 16}, {1, 2, 3, 4, 9, 16}}

  return 0;
}
