#include "part1.hpp"

/*
  This is the test-code for question 1 in part 1. If you type 
  
  make part1-question1

  in the terminal, you will start a compiling if this code and an
  execution of the resulting program. Your job is to modify the files
  part1.hpp and part1.cpp (the comments there tell you where to add 
  the code) until compilation goes without errors and without warnings,
  and until the execution is the one expected.
*/

int main(int argc, char* argv[]) {

  auto a = make_ref("tata");
  auto o = make_ref("toto");
  auto i = make_ref("titi");
  auto u = make_ref("tutu");

  ref_set A {a, o, i, u};
  ref_set B {a};
  ref_set C {};

  std::cout << A << ", " << B << ", " << C << std::endl;
  // Exected output :
  // {tata, toto, titi, tutu}, {tata}, {}

  return 0;
}
