#include "part1.hpp"
#include <iomanip>

int main(int argc, char* argv[]) {

  auto a = make_ref("tata");
  auto o = make_ref("toto");
  auto i = make_ref("titi");
  auto u = make_ref("tutu");
  auto U = make_ref("tutu");

  ref_set A {a, o, u};
  auto    B = empty_set();

  std::cout << std::boolalpha
	    << A
	    << ", " << has(A, i) << ", " << has(B, i)
	    << ", " << has(A, u) << ", " << has(A, U) << std::endl;
  // Exected output (check the last boolean):
  // {tata, toto, tutu}, false, false, true, true

  if(!has(A, U))
    std::cout << std::endl
	      << std::endl
	      << "!!!! WARNING !!!!" << std::endl
	      << "if you see this, your implementation of" << std::endl
	      << "the has(,) function is wrong." << std::endl
	      << std::endl;
  
  return 0;
}
