#pragma once

#include <iostream>
#include <string>
#include <memory>
#include <vector>

using content = std::string;
using ref     = std::shared_ptr<content>;
using ref_set = std::vector<ref>;


// ==== Part 1, question 1 code hereafter

// Implement these two functions in part1.cpp
ref make_ref(const std::string& value);
std::ostream& operator<<(std::ostream& os, const ref_set& rs);





// ==== Part 1, question 2 code hereafter

// Uncomment this line to activate the code
// #define P1Q2
#ifdef P1Q2

// Implement these functions in part1.cpp
ref_set empty_set();
bool    has(the_set, ref elem); // Type for 'the_set' argument is missing.

#endif // End of Part 1, question 2 code





// ==== Part 1, question 3 code hereafter

// Uncomment this line to activate the code
// #define P1Q3
#ifdef P1Q3

// Implement these functions in part1.cpp
void insert(the_set, ref elem); // Type for 'the_set' argument is missing.

// Once insert is done, implement a += operator that calls insert,
// so that expression
// S += a;
// does the same as
// insert(S, a);

// Then uncomment the following line and implement the function.
// void remove_duplicates(the_set); // Type for 'the_set' argument is missing.

#endif // End of Part 1, question 3 code





// ==== Part 1, question 4 code hereafter

// Implement the following functions in part1.cpp, but declare their
// header here as we did so far.

// Implement a union and a intersection function as the || and && operator,
// so that A || B is the union and A && B the instersection of sets A and B.

// Implement a == operator such as A == B tells wether A and B have the same elements.
