#include <iostream>
#include "part2.hpp"

int main(int argc, char* argv[]) {
  auto O = ref_set::empty_set();
  
  auto ta = ref_set::make_ref("tata");
  auto to = ref_set::make_ref("toto");
  auto ti = ref_set::make_ref("titi");
  auto tu = ref_set::make_ref("tutu");
  auto tU = ref_set::make_ref("tutu");
  auto ra = ref_set::make_ref("rara");
  auto ro = ref_set::make_ref("roro");
  auto za = ref_set::make_ref("zaza");
  auto zo = ref_set::make_ref("zozo");

  ref_set A {ta, to, ti, tu, za, za, za, to, to, to, ti, ti, ti, ti, ti};
  ref_set B {ti, tU, ra, ro};
  B += zo;
  ref_set C = A || B;
  ref_set D = A && B;

  // The order in the inputs is allowed to be different for you.
  std::cout << O << std::endl  // Output : {}
	    << A << std::endl  // Output : {tata, toto, titi, tutu, zaza}
	    << B << std::endl  // output : {titi, tutu, rara, roro, zozo}
	    << C << std::endl  // Output : {tata, toto, titi, tutu, zaza, rara, roro, zozo}
	    << D << std::endl; // output : {titi, tutu}

  return 0;
}
